#!/bin/bash

cd files

check_stuff(){
echo " "
echo "################ Checking needed stuff ################"
for i in rfcomm gpsd sdptool; do
	RESULT=`which $i`
	printf "Checking $i "
	if [ -z "$RESULT" ]; then
	echo "- NOT FOUND
Install $i or, if You have it in place not set in default environement
set full path in /usr/local/bin/bt-gps.sh Definitions section"
	yes_no || exit 1
	else
	echo "- found as $RESULT - ## OK ##"
	fi
done
echo "######################################################"
}

check_channel(){
echo "######## Check for available bluetooth channel #######"
TMPCH=3
if [ -n "`sdptool browse local | grep 'Failed to connect to SDP server on FF:FF:FF:00:00:00'`" ]; then
  if [ -e "/usr/lib/systemd/system/bluetooth.service" ]; then
    BTSERVICE=/usr/lib/systemd/system/bluetooth.service
  fi
  if [ -e "/lib/systemd/system/bluetooth.service" ]; then
    BTSERVICE=/lib/systemd/system/bluetooth.service
  fi
  if [ -e "/etc/systemd/system/bluetooth.service" ]; then
    BTSERVICE=/etc/systemd/system/bluetooth.service
  fi
  sed -i '/ExecStart/s/bluetoothd.*/bluetoothd --compat/' $BTSERVICE
  systemctl daemon-reload
  systemctl restart bluetooth
  sleep 1
fi
for i in 3 4 5 6 7 8 9 10; do
  if [ -z "`sdptool browse local | grep Channel | grep $i`" ]; then
    TMPCH=$i
    break
  fi
done
echo "Channel = $TMPCH"
echo "######################################################"
}

check_device(){
echo "######## Check for available rfcomm device #######"

TMPDEV=rfcomm9

for i in 9 10 11 12 13 14 15; do
  if [ ! -e /dev/rfcomm$i ]; then
    TMPDEV=rfcomm$i
    break
  fi
done

echo "Device = /dev/$TMPDEV"
echo "######################################################"
}

installit(){
echo " "
echo "################# Installing stuff ####################"
echo " "
echo "Copying files & setting systemd"

cp bt-gps.sh /usr/local/bin/
chmod 755 /usr/local/bin/bt-gps.sh
chown root:root /usr/local/bin/bt-gps.sh 
sed -i '/DEVICE=/s/rfcomm.*/'$TMPDEV'/' /usr/local/bin/bt-gps.sh
sed -i 's/CHANNEL=.*/CHANNEL='$TMPCH'/' /usr/local/bin/bt-gps.sh

cp bt-gpsd.service /etc/systemd/system/
chown root:root /etc/systemd/system/bt-gpsd.service
FULLGPSD=`which gpsd`
sed -i 's@ExecStart.*@ExecStart='$FULLGPSD' -N -n -b /dev/'$TMPDEV'@' /etc/systemd/system/bt-gpsd.service

cp bt-gpsd.socket /etc/systemd/system/
chown root:root /etc/systemd/system/bt-gpsd.socket

cp bt-gps.service /etc/systemd/system/
chown root:root /etc/systemd/system/bt-gps.service
systemctl daemon-reload
systemctl enable bt-gps
systemctl start bt-gps
echo " "
echo "Files added:
/etc/systemd/system/bt-gps.service 
/etc/systemd/system/bt-gpsd.service 
/etc/systemd/system/bt-gpsd.socket 
/usr/local/bin/bt-gps.sh"
echo " "
echo "#################### Done ############################"
echo " "
exit 0
}

[ `id -u` -ne 0 ] && echo "This script needs admin privileges
Login as root or use sudo command (# sudo ./install.sh)" && exit 1
check_stuff
check_channel
check_device
installit
echo "Bye" 
